      SUBROUTINE KINIT
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 3009
C   Date      : 1995.01.07
C   Last update : 1995.02.20  Y. Kurihara
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
C
      IMPLICIT REAL*8(A-H,O-Z)
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
      common/usrset/E0,Ea,THEa,IPS,IRUNA,IRUNW,INEUT
 
      CHARACTER XSTR*14
 
      INCLUDE 'inclk.f'
*-----------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3,ICOS4,isr
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2,2)
      common /knmflg/ knmgvs, knmhst, knmsfp, knmisr
*- QEDPS ---------------------------------------------------------------
      COMMON/CUTQP /IQEDPS,NOBPHO,COSPHO,EPHOCT,COSOPN
      common/QPRNDM/xrnd(101),ipnt,irdmax
      COMMON/QEDPS1/NALP,NQED
     .,             Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,             IBR,NPH,iradi(10)
*-----------------------------------------------------------------------
* 3-body kinematics
*
*  Integration variables
*        COS(the3),Phi3(=0)
*        Q2=(p4+p5)**2
*        COS(the4^),Phi4^    in particle 4,5 CM frame
*
*                         /P4
*                        /
*           p1\         /
*              \      q/\
*               ***** /  \
*              *******    \P5
*               ***** \
*               /      \
*              /        \
*           p2/          \p3
*
*
*--- 1. Initialize constants for kinematics.
* S = (P1+P2)**2
* W = SQRT(S)
      if( knmgvs .eq. 1 ) then
      W =  E0
      endif
      S = W*W
      totmas=amass1(3)+amass1(4)+amass1(5)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
*******************************
* Angular cuts in Lab-frame.  *
*******************************
      thea=THEa
* particle 3
* minimum cos  cut
      COSCUT(1,1)= -cos(thea*rad)
* maximum cos  cut
      COSCUT(2,1)=  cos(thea*rad)
* particle 4
      thec=0
* minimum cos  cut
      COSCUT(1,2)= -cos(thec*rad)
* maximum cos  cut
      COSCUT(2,2)=  cos(thec*rad)
* particle 5
* minimum cos  cut
      COSCUT(1,3)= -cos(thec*rad)
* maximum cos  cut
      COSCUT(2,3)=  cos(thec*rad)
 
*******************************
* Energy  cuts in Lab-frame.  *
*******************************
* particle 3
* minimum energy cut
      ENGYCT(1,1) = Ea
* maximum energy cut
      ENGYCT(2,1) = (s+amass2(3)-(amass1(4)+amass1(5))**2)/2.d0/w
* particle 4
* minimum energy cut
      ENGYCT(1,2) = AMASS1(4)
* maximum energy cut
      ENGYCT(2,2) = (s+amass2(4)-(amass1(5)+amass1(3))**2)/2.d0/w
* particle 5
* minimum energy cut
      ENGYCT(1,3) = AMASS1(5)
* maximum energy cut
      ENGYCT(2,3) = (s+amass2(5)-(amass1(3)+amass1(4))**2)/2.d0/w
 
*******************************
* Cut on invariant mass of 4-5*
*******************************
* minimum
      AMASCT(1)= AMASS1(4)+AMASS1(5)
* maximum
      AMASCT(2)= W-AMASS1(3)
 
*******************************
* Q2 singularity treatment    *
*******************************
* no-singularity           : IRESNS= 0
* narrow resonance (single): IRESNS= 1
* narrow resonance (single)
* + 1/Q2 singularit        : IRESNS=-1
* narrow resonance (double): IRESNS= 2
* narrow resonance (double)
* + 1/Q2 singularit        : IRESNS=-2
* Q2=S peak                : IRESNS= 3
* 1/Q2 singularity only    : IRESNS=-3
* narrow resonance (single)
* + Q2=S peak              : IRESNS= 4
      IRESNS   = 4
      IF( abs(IRESNS).eq.1 .or.
     .    abs(IRESNS).eq.2 .or.
     .    abs(IRESNS).eq.4 ) then
C If you want treat narrow resonance, you should set resonance mass
C and width. (M1 < M2)
        ARESNS(1,1)=AMz
        ARESNS(2,1)=AGz
        ARESNS(1,2)=AMh
        ARESNS(2,2)=AGh
      END IF
 
****************************************
* angular distribution of particle3    *
****************************************
* no-singularity           : ICOS3=0
* 1/t singularity          : ICOS3=1
* 1/t + 1/u singularity    : ICOS3=2
*
      ICOS3=2
****************************************
* angular distribution of particle 4-5 *
****************************************
* no-singularity           : ICOS4= 0
* z-axis -> -p3
* 1/t singularity          : ICOS4= 1
* 1/t + 1/u singularity    : ICOS4= 2
* z-axis -> p1
* 1/t singularity          : ICOS4=-1
* 1/t + 1/u singularity    : ICOS4=-2
      ICOS4= 0

*-- QEDPS ------------------------------------------------------
C QEDPS IS ON (1) OR OFF(0)
      IQEDPS=Ips
C Particle # for final radiation.
      iradi(3)=0
      iradi(4)=0
      iradi(5)=0
C CUTS FOR RADIATED PHOTONS
C NUMBER OF OBSERVED PHOTON (-1 for no restriction)
      NOBPHO=   1
C ANGULAR CUT FOR OBSERVED PHOTON
      COSPHO=cos(THEa*rad)
C ENERGY CUT  FOR OBSERVED PHOTON
      EPHOCT=Ea
C PHOTON-final particles OPENING ANGLE
      ANGL=0
      COSOPN=COS(ANGL*RAD)
*-- Running alpha-----------------------------------------------
      iralph=Iruna
      if(iralph.eq.3)iralph=0
      call raint(iralph)

      WRITE(11,*)'*'
      WRITE(11,*)'* Kinematics initialization '
      WRITE(11,*)'* particle mass ',amass1
      WRITE(11,*)'* CM Energy ',W
      WRITE(11,*)'* COSCUT    '
      WRITE(11,'(2F10.3)')COSCUT
      WRITE(11,*)'* ENGYCT    '
      WRITE(11,'(2F10.3)')ENGYCT
      WRITE(11,*)'* AMASCT    '
      WRITE(11,'(2F10.3)')AMASCT
      WRITE(11,*)'* Singularity treatment '
      WRITE(11,*)'*   Q2'
      IF     (IRESNS.EQ.-3) THEN
         WRITE(11,*)'* 1/Q2 singularity '
      ELSE IF(IRESNS.EQ. 3) THEN
         WRITE(11,*)'* Q2=S peak        '
      ELSE IF(IRESNS.EQ. 0) THEN
         WRITE(11,*)'* NO   singularity '
      ELSE 
         WRITE(11,*)'* Narrow resonance '
         if(iresns.lt.0)then
         write(11,*)'* +1/Q2 singularity '
         else if(iresns.eq.4) then
         write(11,*)'* +Q2=s peak '
         end if
         WRITE(11,*)'*  resonance mass and width'
         WRITE(11,*) ARESNS
      END IF
      write(11,*)'* particle 3   : ',icos3
      write(11,*)'* particle 4-5 : ',icos4
      WRITE(11,*)'* Initial State Radiation = ',iqedps
      WRITE(11,*)'* Running alpha ',iralph
      if(iralph.eq.1) then
	al=alpha*ralph(s)
        WRITE(11,*)'* 1/alpha at CM energy ',1.d0/al
      end if
      WRITE(11,*)'*'
C SET QEDPS PARAMETERS
      IF(IQEDPS.EQ.1)CALL QPINPT
C Calculation of Sudakov form factor
      IF(IQEDPS.EQ.1)CALL QPPREP
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 2. Dimension of integration variables.
 
c       if(iqedps.eq.0) then
          NDIM =   5
          NWILD=   5
c       else if(iqedps.eq.1) then
c         NDIM =   50
c         NWILD=   4
c         irdmax=ndim+1
          irdmax=101
c       else
c         write(6,*)'* kinit: iqedps = ',iqedps,' is not supported.'
c         stop
c       end if
 
C-----------------------------------------------------------------------
*--- 3. Region of integration.
 
        DO 1 I=1,NDIM
         XL(I)  =   0.D0
         XU(I)  =   1.D0
         if(i.le.4) then
         IG(I)  =   1
         else
         IG(I)  =   0
         end if
1       CONTINUE
C-----------------------------------------------------------------------
*--- 4. Number of iterations
c     ITMX1  =   5
c     ITMX2  =   5
 
c     NCALL  = 2500000*4
 
*--- 5. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 6. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50
      ND = 50
 
c     DO 100 I = 1, NDIM
c        WRITE(XSTR, 110) I
c 110    FORMAT('X(',I2,') SPECTRUM')
c        CALL XHINIT(I, XL(I), XU(I), NX, XSTR)
c 100 CONTINUE
         CALL XHINIT(1, 0.d0, w, NX, 'Energy of Particle 3')
         CALL XHINIT(2, 0.d0, w, NX, 'Energy of Particle 4')
         CALL XHINIT(3, 0.d0, w, NX, 'Energy of Particle 5')
         CALL XHINIT(4,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT(5,-1.d0,1.d0, NX, 'cos_the of Particle 4')
         CALL XHINIT(6,-1.d0,1.d0, NX, 'cos_the of Particle 5')
*--
         CALL XHINIT(7, 0.d0, w, NX, 'Invariant Mass 3-4')
         CALL XHINIT(8, 0.d0, w, NX, 'Invariant Mass 3-5')
         CALL XHINIT(9, 0.d0, w, NX, 'Invariant Mass 4-5')
*--
         CALL XHINIT(10,-1.d0,1.d0, NX, 'cos_the between 3-4')
         CALL XHINIT(11,-1.d0,1.d0, NX, 'cos_the between 3-5')
         CALL XHINIT(12,-1.d0,1.d0, NX, 'cos_the between 4-5')
*--
         CALL XHINIT(13,amass1(4)+amass1(5),w, NX, 'ds/dQ')
         CALL XHINIT(14,-w/2.d0,w/2.d0, 49, 'ds/dQz')
         CALL XHINIT(15, 0.d0,w/2.d0, NX, 'ds/dQt')
         CALL XHINIT(16, 0.d0,w/2.d0, NX, 'ds/dE(gamma)')
         CALL XHINIT(17, 0.d0,w/2.d0, NX, 'ds/dPt(gamma)')
         CALL XHINIT(18, 0.d0,w/2.d0, NX, 'ds/dE(PSgamma)')
         CALL XHINIT(19, 0.d0,w/2.d0, NX, 'ds/dPt(PSgamma)')
         CALL XHINIT(20, 0.d0,10.d0, 10, '#photons')

         CALL XHINIT(21,  0.d0,150.d0, 50, 'missing mass')
         CALL XHINIT(22,150.d0,210.d0, 20, 'missing mass')
 
      endif
      RETURN
      END
