C       SUBROUTINE ANNH(Q2,NOK) ! ORIGINAL NAME
C       SUBROUTINE QPANNH(Q2,NOK)
C         determine the virtual mass squared of the virtual photon
C         Then decide to accept or not its value according to
C         the probability (1/Q2)
C
C
C
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
        SUBROUTINE QPANNH(Q2,NOK)
        IMPLICIT REAL*8(A-H,O-Z)
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------


          NOK=0
          P0X=0.0
          P0Y=0.0
          P0Z=0.0
          P0E=0.0

          LL = 0
         DO 1 I=1,NTOP
          IF( NLPTN(6,I).LT.0  .AND.  NLPTN(3,I).EQ.0)THEN
          P0X = P0X + PLPTN(4,I)
          P0Y = P0Y + PLPTN(5,I)
          P0Z = P0Z + PLPTN(6,I)
          P0E = P0E + PLPTN(7,I)
          LL = LL + 1
                                                     ENDIF
 1       CONTINUE
         IF( LL.NE.2)WRITE(6,*)'ERROR AT ANNH, LL=',LL
CCCC     IF( LL.NE.2)CALL OUTLST
CCCC     IF( ABS(P0E) .GT. 1.0D10 )CALL OUTLST
         IF(     P0E  .LE. 0.0D0  )RETURN

c       WRITE(6,*)'P0X,P0Y,P0Z,P0E=',P0X,P0Y,P0Z,P0E
         Q2 = P0E**2 - P0X**2 - P0Y**2 - P0Z**2
c       WRITE(6,*)' Q2 =',Q2,q2min

c       call QPdump
         IF(  Q2 .LT. Q2MIN) RETURN

 110    CONTINUE


          L=NTOP + 1
         PLPTN(1,L)=1.0
         PLPTN(2,L)= Q2
         PLPTN(4,L)= P0X
         PLPTN(5,L)= P0Y
         PLPTN(6,L)= P0Z
         PLPTN(7,L)= P0E

         NLPTN(1,L) = 0
         NLPTN(2,L) = 0
         NLPTN(3,L) = 0
         NLPTN(4,L) = 0
         NLPTN(5,L) = 0
         NLPTN(6,L) = 1


         NTOP = NTOP +1
         NOK  = 1


           RETURN
           END
c       SUBROUTINE corr(xxx)  ! ORIGINAL NAME
c       SUBROUTINE QPcorr(xxx,iok)
c      compensate the finite contribution due to doulble cascade
c
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      09/Aug./'95
C
         SUBROUTINE QPcorr(xxx,iok)
         IMPLICIT REAL*8(A-H,O-Z)
         include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,               Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,               IBR,NPH
        COMMON/KINEM1/S,ECM
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        common/QPRNDM/xrnd(101),ipnt,irdmax
        COMMON /QPcrrp/zbmin
c       data alpha0/7.2973531d-3/
        data zbmin/1.0d-4/
****************************************************************
        iok=1
          z = 0.0d0
         fm= QPfint(1,0.1d0)
c        if( random(1) .le. fm )then
         xxrnd=xrnd(ipnt)
         ipnt=ipnt+1
         if(ipnt.gt.irdmax) then
          iok=0
          return
         end if
         if( xxrnd .le. fm )then
             z2lmn=log(zbmin)**2
             z2lmx=log(1.0d0)**2
           dz2l = z2lmx - z2lmn
             fmx = 1.0d0/2.0d0/pi*alpha0 *2.5d0
         do 35 i=1,30
c           z2l= z2lmn+random(1)*dz2l
           z2l= z2lmn+xrnd(ipnt)*dz2l
           ipnt=ipnt+1
           if(ipnt.gt.irdmax) then
            iok=0
            return
           end if
           fx = QPfint(2,z2l)
           if( fmx .le. fx)then
            write(6,*)' fmx < finta ',fmx,fx,' z2l= ',z2l
            z1 =exp(-sqrt(z2l))
            z = 1.0d0 - z1
            zs = sqrt(z)
            fintx =(log(z1/(1.0d0+zs))*(1.0d0+z*z)
     &   -2.0d0*z*log(zs/(1.0d0+zs))+z*z1*log(zs))/log(z1)

c
           ftx =2/sqrt(z)
            write(6,*)'z1,z,zs=',z1,z,zs,' fintx =',fintx,'ftx =',ftx
                           endif
c          if( fmx*random(1) .le. fx)goto 36
           xxrnd=xrnd(ipnt)
           ipnt=ipnt+1
           if(ipnt.gt.irdmax) then
            iok=0
            return
           end if
           if( fmx*xxrnd .le. fx)goto 36
 35       continue
          write(6,*)' fail to fix z '
 36       continue
          z = exp(-sqrt(z2l))
          z=1.0d0 -z
cx            write(6,*)' z,fx,fmx=',z,fx,fmx
                           else
           z =1.0d0
                           endif
          xxx = z
          return
          end

      FUNCTION  QPfint(nnn,z2l)
      IMPLICIT REAL*8(A-H,O-Z)
      include 'inclk.h'
      COMMON /QPcrrp/zbmin
c     data alpha0/7.2973531d-3/
ccccccccccccc
c      finite contribution
c
c          z1 = 1 - z
c          z1s = 1 - sqrt(z)
c        f(z) =C*delat(z1)-1/2/pi*alpha*log(z1s)/z1*(2-2z1+z1**2)
c                  -1/2/pi*alpha*(-2z/z1 log(sqrt(z)/(1+sqrt(z))
c                  -1/2/pi*alpha*(zlog(sqrt(z))
c
c        C is fixed by int (f(z)) = 1
c
c         variable z2l =log(z1)**2
ccccccccccc
       fac =1.0/2.0d0/pi*alpha0
       if(nnn .eq. 1)then
cx           finta =fac*(log(zbmin))**2
           QPfint =1.0d0-exp(-fac*(log(zbmin))**2)
           if( QPfint .ge. 1.0d0)then
            write(6,*)'  int finta > 1 '
            write(6,*)' zbmin,fac,finita =',zbmin,fac,finita
            stop
                                endif
                     else
            z1 =exp(-sqrt(z2l))
            z = 1.0d0 - z1
            zs = sqrt(z)
cxxx           finta =fac*(log(z1/(1.0d0+zs))*(1.0d0+z*z)
cxxxx     &   -2.0d0*z*log(zs/(1.0d0+zs))+z*z1*log(zs))/log(z1)
           QPfint =fac*(log(z1/(1.0d0+zs))*(1.0d0+z*z)
     &   +2.0d0*log((1.0+zs)/zs)+z1**2*log(zs)
     &   - (zs-z)*z1)/log(z1)
c
c
        QPfint=QPfint*exp(-fac*(log(z1))**2)

c
           if( QPfint .le. 0.0d0)then
cx            write(6,*)'  finta < 0 '
cx            write(6,*)' z2l,z1,,fac,finta =',z2l,z1,fac,QPfint
cx              stop
                                endif
                     endif

        return
        end
cccccc    end   ccccccccccccccccc
ccccccccccc    improved QEDPS    1995.8.8
ccccccccccccccccccccccccccccccccccccccccccccccc
C         SUBROUTINE CMSFNL(NAD,NVPH) ! ORIGINAL NAME
C         SUBROUTINE QPCSFL(NAD,NVPH)
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      19/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C         Y.Kurihara;To fit for many body final state  30/May /'95
C
          SUBROUTINE QPCSFL(NAD,NVPH,pe,iok)
         IMPLICIT REAL*8(A-H,O-Z)
         include 'incl1.h'
         include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        common/QPRNDM/xrnd(101),ipnt,irdmax
        real*8 pe(4,nextn)
*-----------------------------------------------------------------------
        iok=1
        IF( NAD.EQ. NVPH+1  .AND. NLPTN(5,NAD).NE.2 )THEN
        do 1 ip=3,nextn
         id=NVPH+ip-2
         eng=pe(4,ip)
         ppp=sqrt( (eng-amass1(ip))*(eng+amass1(ip)) )
         plptn(3,id)=0
         plptn(4,id)=0
         plptn(5,id)=0
         plptn(6,id)=ppp
         plptn(7,id)=eng
         plptn(8,id)=( ppp+eng)/sqrt(2.d0)
         plptn(9,id)=(-ppp+eng)/sqrt(2.d0)
         nlptn(5,id)=2
1       continue
                                   RETURN
                                    ENDIF
C
        NCH = NAD + NLPTN(4,NAD)
        L1 = NCH
        L2 = L1 + 1
        X= PLPTN(1,L1) / PLPTN(1,NAD)
      IF( X .LE. 0    .OR.  X .GE. 1.0D0)THEN
        WRITE(6,*)'NAD,L1,L2,X =',NAD,L1,L2,X
CC        CALL OUTLST
                                       ENDIF
        PLPTN(8,L1)= PLPTN(8,NAD)*X
        PLPTN(8,L2)= PLPTN(8,NAD)*(1.0D0-X)

        PT2 = X*(1.0D0-X)
     &  *(PLPTN(2,NAD)-PLPTN(2,L1)/X-PLPTN(2,L2)/(1.0D0-X))
        IF( PT2 .LT. 0)THEN
c             WRITE(6,*)' ERROR AT CMSFNL, PT2<0, PT2=',PT2
c             WRITE(6,*)' NAD,L1,L2,X =',NAD,L1,L2,X
c             CALL QPDUMP
              iok=0
              return
                         ENDIF

         THETA = 2.0D0*PI*xrnd(ipnt)
         ipnt=ipnt+1
         if(ipnt.gt.irdmax) then
          iok=0
          return
         end if
         PT = SQRT( PT2 )
         PX = PT*COS(THETA)
         PY = PT*SIN(THETA)

         PLPTN(3,L1) = PT2
         PLPTN(3,L2) = PT2
         PLPTN(4,L1) = PLPTN(4,NAD)*X         + PX
         PLPTN(4,L2) = PLPTN(4,NAD)*(1.0D0-X) - PX
         PLPTN(5,L1) = PLPTN(5,NAD)*X         + PY
         PLPTN(5,L2) = PLPTN(5,NAD)*(1.0D0-X) - PY
         PLPTN(9,L1)=(PLPTN(2,L1)
     &    +PLPTN(4,L1)**2+PLPTN(5,L1)**2)/PLPTN(8,L1)/2.0D0
         PLPTN(9,L2)=(PLPTN(2,L2)
     &    +PLPTN(4,L2)**2+PLPTN(5,L2)**2)/PLPTN(8,L2)/2.0D0

         PLPTN(6,L1)=( PLPTN(8,L1)-PLPTN(9,L1) )/SQRT(2.0D0)
         PLPTN(6,L2)=( PLPTN(8,L2)-PLPTN(9,L2) )/SQRT(2.0D0)
c        IF( NLPTN(1,NAD).GT. 0) THEN
c             PLPTN(6,L1) = - PLPTN(6,L1)
c             PLPTN(6,L2) = - PLPTN(6,L2)
c                                ENDIF

         PLPTN(7,L1)=( PLPTN(8,L1)+PLPTN(9,L1) )/SQRT(2.0D0)
         PLPTN(7,L2)=( PLPTN(8,L2)+PLPTN(9,L2) )/SQRT(2.0D0)

C
c        write(6,*)'QPCSFL:'
c        WRITE(6,*)'NAD,P(I)',NAD,(PLPTN(I,NAD),I=1,9)
c        WRITE(6,*)'L1 ,P(I)',L1 ,(PLPTN(I,L1 ),I=1,9)
c        WRITE(6,*)'L2 ,P(I)',L2 ,(PLPTN(I,L2 ),I=1,9)
c        write(6,*)plptn(4,nad),plptn(4,l1)+plptn(4,l2)
c        write(6,*)plptn(5,nad),plptn(5,l1)+plptn(5,l2)
c        write(6,*)plptn(6,nad),plptn(6,l1)+plptn(6,l2)
c        write(6,*)plptn(7,nad),plptn(7,l1)+plptn(7,l2)
c        write(6,*)plptn(2,nad),plptn(7,nad)**2
c    .                         -plptn(4,nad)**2
c    .                         -plptn(5,nad)**2
c    .                         -plptn(6,nad)**2
c        write(6,*)plptn(2,l1),plptn(7,l1)**2
c    .                         -plptn(4,l1)**2
c    .                         -plptn(5,l1)**2
c    .                         -plptn(6,l1)**2
c        write(6,*)plptn(2,l2),plptn(7,l2)**2
c    .                         -plptn(4,l2)**2
c    .                         -plptn(5,l2)**2
c    .                         -plptn(6,l2)**2
C
         NLPTN(5,L1) = 2
         NLPTN(5,L2) = 2

          RETURN
          END
C         SUBROUTINE CMSINT(NAD) ! ORIGINAL NAME
C         SUBROUTINE QPCSIN(NAD)
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
          SUBROUTINE QPCSIN(NAD,iok)

         IMPLICIT REAL*8(A-H,O-Z)
        COMMON /AMCNST/ PI, PI2, RAD, GEVPB
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        common/QPRNDM/xrnd(101),ipnt,irdmax
*-----------------------------------------------------------------------
        iok=1
        IF( NAD.EQ.1 .OR. NAD.EQ.2 )THEN
                                   NLPTN(5,NAD)=2
                                   RETURN
                                    ENDIF

        NPR = NAD - NLPTN(2,NAD)
        L1 = NAD
        L2 = L1 + 1
        X= PLPTN(1,L1) / PLPTN(1,NPR)
        PLPTN(8,L1)= PLPTN(8,NPR)*X
        PLPTN(8,L2)= PLPTN(8,NPR)*(1.0D0-X)

        PT2=X*(1.0D0-X)
     &  *(PLPTN(2,NPR)-PLPTN(2,L1)/X-PLPTN(2,L2)/(1.0D0-X))
        IF( PT2 .LT. 0.0)THEN
              WRITE(6,*)' ERROR AT CMSINT, PT2<0, PT2=',PT2
              write(6,*)' NPR,L1,L2 ',NPR,L1,L2
CCC           CALL OUTLST
              iok=0
              return
                         ENDIF

         THETA = 2.0D0*PI*xrnd(ipnt)
         ipnt=ipnt+1
         if(ipnt.gt.irdmax) then
          iok=0
          return
         end if
         PT = SQRT( PT2 )
         PX = PT*COS(THETA)
         PY = PT*SIN(THETA)

         PLPTN(3,L1) = PT2
         PLPTN(3,L2) = PT2
         PLPTN(4,L1) = PLPTN(4,NPR)*X         + PX
         PLPTN(4,L2) = PLPTN(4,NPR)*(1.0D0-X) - PX
         PLPTN(5,L1) = PLPTN(5,NPR)*X         + PY
         PLPTN(5,L2) = PLPTN(5,NPR)*(1.0D0-X) - PY
         PLPTN(9,L1)=(PLPTN(2,L1)
     &   +PLPTN(4,L1)**2+PLPTN(5,L1)**2)/PLPTN(8,L1)/2.0D0
         PLPTN(9,L2)=(PLPTN(2,L2)
     &   +PLPTN(4,L2)**2+PLPTN(5,L2)**2)/PLPTN(8,L2)/2.0D0

         PLPTN(6,L1)=( PLPTN(8,L1)-PLPTN(9,L1) )/SQRT(2.0D0)
         PLPTN(6,L2)=( PLPTN(8,L2)-PLPTN(9,L2) )/SQRT(2.0D0)
c        IF( NLPTN(1,L1) .GE. 0) THEN
         IF( NLPTN(1,L1) .EQ. 2) THEN
              PLPTN(6,L1) = - PLPTN(6,L1)
              PLPTN(6,L2) = - PLPTN(6,L2)
                                 ENDIF

         PLPTN(7,L1)=( PLPTN(8,L1)+PLPTN(9,L1) )/SQRT(2.0D0)
         PLPTN(7,L2)=( PLPTN(8,L2)+PLPTN(9,L2) )/SQRT(2.0D0)

c        write(6,*)'QPCSIN:'
c        WRITE(6,*)'NPR,P(I)',NPR,(PLPTN(I,NPR),I=1,9)
c        WRITE(6,*)'L1 ,P(I)',L1 ,(PLPTN(I,L1 ),I=1,9)
c        WRITE(6,*)'L2 ,P(I)',L2 ,(PLPTN(I,L2 ),I=1,9)
c        write(6,*)plptn(4,nPR),plptn(4,l1)+plptn(4,l2)
c        write(6,*)plptn(5,nPR),plptn(5,l1)+plptn(5,l2)
c        write(6,*)plptn(6,nPR),plptn(6,l1)+plptn(6,l2)
c        write(6,*)plptn(7,npr),plptn(7,l1)+plptn(7,l2)
c        write(6,*)plptn(2,npr),plptn(7,npr)**2
c    .                         -plptn(4,npr)**2
c    .                         -plptn(5,npr)**2
c    .                         -plptn(6,npr)**2
c        write(6,*)plptn(2,l1),plptn(7,l1)**2
c    .                         -plptn(4,l1)**2
c    .                         -plptn(5,l1)**2
c    .                         -plptn(6,l1)**2
C


         NLPTN(5,L1) = 2
         NLPTN(5,L2) = 2

          RETURN
          END
C        SUBROUTINE OUTLST ! ORIGINAL NAME
C        SUBROUTINE QPDUMP
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      19/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
         SUBROUTINE QPDUMP

         IMPLICIT REAL*8(A-H,O-Z)
        COMMON /AMCNST/ PI, PI2, RAD, GEVPB
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
        DIMENSION PSUM(3)

        WRITE(6,101)NTOP
 101    FORMAT(' LIST OF OUTPUT, # OF LISTS=',I5)
        WRITE(6,102)
 102    FORMAT('     ID',6X,' X ',6X,'Q2',8X,'PT2',8X,'PX',8X,'PY',8X,
     &  'PZ',8X,'E',7X,'NLPTN(I,*)=',
     &  ' I=2',' I=3',' I=4',' I=5',' I=6')


        DO 110 I =1,NTOP
        WRITE(6,103)I,NLPTN(1,I),(PLPTN(K,I),K=1,7),(NLPTN(K,I),K=2,6)
C
 110    CONTINUE

 103    FORMAT(' ',I3,I3,2X,7(G9.2,1X),3X,5I3)
C
        DO 203 I=1,3
 203    PSUM(I)=0.0
C
        pesum=0
        DO 201  J=1,NTOP
      IF( NLPTN(3,J).EQ.0 .AND. NLPTN(6,J) .GT. 0)THEN
        pesum=pesum+plptn(7,j)
        DO 202 I=1,3
 202    PSUM(I)=PSUM(I) + PLPTN(3+I,J)
                                                  ENDIF
 201   CONTINUE
C
       PSUM2 = 0.0
        DO 204 I=1,3
 204    PSUM2  =PSUM(I)**2 + PSUM2
C
        write(6,*)' psum2 ',psum2
        write(6,*)' pesum ',pesum
        IF( PSUM2 .GT. 1.0E-3)THEN
        WRITE(6,*)' MOMENTUM CONSERVATION ???'
        WRITE(6,*)'  MOMENTUM SUM =',(PSUM(I),I=1,3)
                              ENDIF
C

        RETURN
        END
C      SUBROUTINE PSFNL(NVPH,X,FX) ORIGINAL NAME
C      SUBROUTINE QPFNL(NVPH)
C
C
C         PLPTN(1, ):  The lightcone fraction
C         PLPTN(2, ):  virtual mass squared
C         PLPTN(3, ):  Pt**2
C         PLPTN(4, ):  x-component of the four momentum
C         PLPTN(5, ):  y-component of the four momentum
C         PLPTN(6, ):  z-component of the four momentum
C         PLPTN(7, ):  E-component of the four momentum
C         PLPTN(8, ):  + component of the lightcone momentum
C         PLPTN(9, ):  - component of the lightcone momentum
C
C         NLPTN(1, ): particle ID=particle# used in GRACE generation
C         NLPTN(2, ): relative address of the parent
C         NLPTN(3, ): number of the children
C         NLPTN(4, ): relative address of the first child
C         NLPTN(5, ): status of the process
C         NLPTN(6, ): spacelike(-1) or timelike(+1)
C
C Auther: T.Munehisa
C         J.Fujimoto;Modified to fit       BASES.      17/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C         Y.Kurihara;To fit for many body final state  30/May /'95
C
C
       SUBROUTINE QPFNL(NVPH,pe,iok)
        IMPLICIT REAL*8(A-H,O-Z)

        include 'incl1.h'
        include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        real*8 pe(4,nextn)
*-----------------------------------------------------------------------
        iok=1
C NVPH :  ADDRESS OF THE VIRTUAL PHOTON
C
        IF(  NVPH .NE. NTOP)WRITE(6,*)' ERROR, NVPH,NTOP',NVPH,NTOP

          DO   1  LID =3,nextn

          NTOP = NTOP + 1
          L = NTOP
          PLPTN(1,L) = 1.0

          NLPTN(1,L) = lid
          NLPTN(2,L) = L  - NVPH
          NLPTN(5,L) = 0
          NLPTN(6,L) = 1

  1       CONTINUE
          NLPTN(3,NVPH) = nextn-2
          NLPTN(4,NVPH) = 1

C      branching

CJF
 111      CONTINUE
          NTOP0=NTOP
          NVPH0=NVPH
CJF END
          NAD = NTOP - (nextn-3)
C         NVPH = NTOP - 2

   2      CONTINUE
          IF( NLPTN(5,NAD) .EQ. 0) THEN
          CALL QPLMQ2(Q2MX,NAD,pe)
          CALL QPGEN2(Q2MX,NAD,nvph,iok)
          if(iok.eq.0) return
                                   ENDIF
           NAD = NAD + 1
          IF( NAD .LE. NTOP) GOTO 2

         return
*******************************************************************
         entry QPFNL2(NVPH,pe,iok)

              L=NVPH+1
         CALL QPCSFL(L,NVPH,pe,iok)
          if(iok.eq.0) return
C
         DO 3 L=NVPH+1 ,NTOP
         IF( NLPTN(3,L) .EQ. 0)GOTO 3
         CALL QPCSFL(L,NVPH,pe,iok)
          if(iok.eq.0) return
 3       CONTINUE

         RETURN
         END
C         SUBROUTINE PSGEN1(NAD0  ! ORIGINAL NAME
C         SUBROUTINE QPGEN1(NAD)
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C         T.Munehisa;improved QEDPS inctalled by Y.K   09/Aug./'95
C
        SUBROUTINE QPGEN1(NAD,iok)
        IMPLICIT REAL*8(A-H,O-Z)
        include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        common/QPRNDM/xrnd(101),ipnt,irdmax
        real*8 kappa/1.0000d0/ 
         REAL*8 K2

         iok=1

C      start of the parton shower
C     NOPS = 1
C          IF( NOPS .EQ. 1) RETURN
C

         ID   = NLPTN(1,NAD)
         Q2MX = Q2MAX / 2
cc       Q2MN = MAX( ABS(PLPTN(2,NAD)) , Q02*4.)
cc       Q2MN = MAX( ABS(PLPTN(2,NAD)) , Q02*10. )
cccccccccccccccc   improved   1995.8.8  ccccccccccc
         Q2MN = MAX( -PLPTN(2,NAD) , q02m)
c        q2mnc = emass**2
         q2mnc = amass2(id)
cccccccccccccccc   improved   1995.8.8  ccccccccccc

c      WRITE(6,*)'  Q2MX,Q2MN = ',Q2MX,Q2MN
c      WRITE(6,113)
c      WRITE(6,112)(PSDK(I),I=1,NSDK)
c112   FORMAT('  ',4(G12.3,3X))
c113   FORMAT('  ARRAY OF THE SUDAKOV FORM FATOR')
  5      CONTINUE
         T1 = LOG(Q2MX / Q02 )
         T2 = LOG(Q2MN / Q02 )
c       WRITE(6,*)'  T1,T2     = ',T1,T2
c       WRITE(6,*)'TMIN,TMAX   = ',TMIN,TMAX

         dt =(tmax-tmin)/dfloat(nsdk)
         LT1 = (T1 - TMIN )/dt
         LT2 = (T2 - TMIN )/dt
      if(lt2.eq.0)lt2=1
c       WRITE(6,*)'  LT1,LT2     = ',LT1,LT2
         IF( LT1 .LE. LT2 ) GOTO 101

cccccccccccccccc   improved   1995.8.8  ccccccccccc
      psdk1 =  PSDK(LT1)+(psdk(lt1+1)-psdk(lt1))*(t1-(lt1*dt+tmin))/dt
      psdk2 =  PSDK(LT2)+(psdk(lt2+1)-psdk(lt2))*(t2-(lt2*dt+tmin))/dt
           p0 = psdk1 - psdk2
c         P0 =  ( PSDK(LT1) - PSDK(LT2) )
cccccccccccccccc   improved   1995.8.8  ccccccccccc
c       WRITE(6,*)'PSDK(LT1),PSDK(LT2) = ',PSDK(LT1),PSDK(LT2)
          P1 = LOG( xrnd(ipnt) )
c         write(6,*)ipnt,irdmax,xrnd(ipnt)
          ipnt=ipnt+1
          if(ipnt.gt.irdmax) then
           iok=0
           return
          end if
c      WRITE(6,*)' P0,   P1=  ',P0,P1
C
          IF ( P1 .LE. P0 ) GOTO 101
cccccccccccccccc   improved   1995.8.8  ccccccccccc
c          P2 = ( P1 ) + PSDK(LT2)
           P2 = ( P1 ) + psdk2
cccccccccccccccc   improved   1995.8.8  ccccccccccc


          DO 201 LT =LT2, LT1
C         IF( P2 .LE. PSDK( LT ))GOTO 202
          IF( PSDK( LT ) .LE. P2 )GOTO 202
  201     CONTINUE

  202     CONTINUE

c       WRITE(6,*)'PSDK(LT),PSDK(LT-1) = ',PSDK(LT),PSDK(LT-1)
C         branching is accepted

          CLT = LT-1 +(P2 -PSDK( LT-1) )/(PSDK(LT)-PSDK(LT-1))
          T = CLT*((TMAX-TMIN)/NSDK ) + TMIN
c         K2 = Q02*EXP(T)
          K2 = exp( log(q02)+ T )
         IF( K2 .LE. Q02)THEN
            WRITE(6,*)'LT1,LT2         = ',LT1,LT2
            WRITE(6,*)'LT,CLT,T,Q02,P2 = ',LT,CLT,T,Q02,P2
            WRITE(6,*)'PSDK(LT),PSDK(LT-1)=',PSDK(LT),PSDK(LT-1)
                             ENDIF
         IF( ABS(Q02/K2). LE. 1.E-20)THEN
            WRITE(6,*)'Q02,K2          = ',Q02,K2
            WRITE(6,*)'LT1,LT2         = ',LT1,LT2
            WRITE(6,*)'LT,CLT,T,Q02,P2 = ',LT,CLT,T,Q02,P2
            WRITE(6,*)'PSDK(LT),PSDK(LT-1)=',PSDK(LT),PSDK(LT-1)
                             ENDIF

C         determine X according to P(x)
          XMAX = 1.0D0 - Q02/K2
          XMIN = 0.0D0
cccccccccccccccc   improved   1995.8.8  ccccccccccc
c         X1LMX=LOG(1.0D0 - XMAX)
c         X1LMN=LOG(1.0D0 - XMIN)
          X1LMX=LOG(q02/k2)
          X1LMN=LOG(1.0D0 - XMIN)
cccccccccccccccc   improved   1995.8.8  ccccccccccc
           X1LD = X1LMX - X1LMN
           PXM =2.0
           DO 203 I=1,200

            X1L = X1LMN + X1LD * xrnd(ipnt)
c         write(6,*)ipnt,irdmax,xrnd(ipnt)
            ipnt=ipnt+1
            if(ipnt.gt.irdmax) then
             iok=0
             return
            end if

             X = 1.0D0 - EXP(X1L)
             X1=  EXP(X1L)
         IF( ABS(X) .GE. 1.1)THEN
            WRITE(6,*)'X, XMAX,X1LD,K2=',X,XMAX,X1LD,K2
            WRITE(6,*)'LT,CLT,T,Q02 = ',LT,CLT,T,Q02
            WRITE(6,*)'PSDK(LT),PSDK(LT-1)=',PSDK(LT),PSDK(LT-1)
                             ENDIF

          PX1= 1.0D0 + X**2

          xxrnd=xrnd(ipnt)
c         write(6,*)ipnt,irdmax,xrnd(ipnt)
          ipnt=ipnt+1
          if(ipnt.gt.irdmax) then
           iok=0
           return
          end if
          IF( PX1 .GE. PXM*xxrnd )GOTO 204
 203      CONTINUE

 204      CONTINUE

C         check the constraint is satisfied or not

c         IF(  (1.0D0-X) .LT. K2/Q2MAX ) THEN
          IF(  X1        .LT. kappa*K2/Q2MAX ) THEN
                                         Q2MN = K2
                                         GOTO 5
                                        ENDIF
cccccccccccccccc   improved   1995.8.8  ccccccccccc
            nmss = 0
             if(nmss .eq. 1)then
           IF(  k2 .le. x1*q2mnc ) THEN
                                         Q2MN = K2
                                        GOTO 5
                                        ENDIF
                            endif
cccccccccccccccc   improved   1995.8.8  ccccccccccc

C         write PLPTN and NLPTN of the children

          L = NTOP+1
          PLPTN(1,L) = X*PLPTN(1,NAD)
          PLPTN(2,L) = - K2

          NLPTN(1,L) = ID
          NLPTN(2,L) = L - NAD
          NLPTN(5,L) = 0
          NLPTN(6,L) = -1

          L = NTOP+2
c         write(6,*)' l ',l
          PLPTN(1,L) =(1.0D0-X)*PLPTN(1,NAD)
          PLPTN(2,L) = 0.0

C        photon does not branch into electron pair (Now, just appx.)
          NLPTN(1,L) = 0
          NLPTN(2,L) = L - NAD
          NLPTN(3,L) = 0
          NLPTN(5,L) = 1
          NLPTN(6,L) = 1

          NLPTN(3,NAD) = 2
          NLPTN(4,NAD) = (L-1) - NAD
          NLPTN(5,NAD) = 1

           NTOP = NTOP + 2

C      WRITE(6,111)
          RETURN

C         not branch
 101      CONTINUE
C       WRITE(6,*)' NOT BRANCH'

          NLPTN(3,NAD) = 0
          NLPTN(4,NAD) = 0
          NLPTN(5,NAD) = 1
C      WRITE(6,111)
 111   FORMAT('   END OF PSGEN1')

          RETURN
          END
C         SUBROUTINE PSGEN2(Q2MX,NAD)  ! ORIGINAL NAME
C         SUBROUTINE QPGEN2(Q2MX,NAD)
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
         SUBROUTINE QPGEN2(Q2MX,NAD,nvph,iok)
         IMPLICIT REAL*8(A-H,O-Z)

        include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH,iradi(10)
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        common/QPRNDM/xrnd(101),ipnt,irdmax
*-----------------------------------------------------------------------
         REAL*8 K2


         iok=1
C      start of the parton shower

         Q2MN = 4.0*Q02M
         ID = NLPTN(1,NAD)
c        Q2MN = max(q02m,10.0*amass2(id))
         IF(  IBR .EQ. 0 ) GOTO 101
         if(iradi(id).eq.0) goto 101

  5      CONTINUE
         IF(  ABS(Q2MX / Q02 ) .LE. 1.)THEN
          WRITE(6,*)'  NAD,Q2MX,Q02=',NAD,Q2MX,Q02
CCC        CALL OUTLST
                                       ENDIF
C
         T1 = LOG(Q2MX / Q02 )
         T2 = LOG(Q2MN / Q02 )

         LT1 = (T1 - TMIN )/( TMAX - TMIN )*NSDK
         LT2 = (T2 - TMIN )/( TMAX - TMIN )*NSDK + 1
         IF( LT1 .LE. LT2 ) GOTO 101
c        IF(  IBR .EQ. 0 ) GOTO 101
C--( FINAL RADIATION ) -------------------------------------------
          P0 =  ( PSDK(LT1) - PSDK(LT2) )
          P1 = LOG( xrnd(ipnt) )
          ipnt=ipnt+1
          if(ipnt.gt.irdmax) then
           iok=0
           return
          end if
          IF ( P1 .LE. P0 ) GOTO 101
           P2 = ( P1 ) + PSDK(LT2)

          DO 201 LT =LT2, LT1
          IF( P2 .GE. PSDK( LT ))GOTO 202
  201     CONTINUE

  202     CONTINUE

C         branching is accepted

          CLT = LT-1 +(P2 -PSDK( LT-1) )/(PSDK(LT)-PSDK(LT-1))
          T = CLT*((TMAX-TMIN)/NSDK ) + TMIN
          K2 = Q02*EXP(T)

C         determine X according to P(x)
C         XMAX = 1.0D0 - Q02/K2
C         XMIN = 0.0D0
        DD =(K2+Q02M-Q02)**2-4.0*K2*Q02M
           XMAX = (K2+Q02M-Q02 +SQRT(DD))/2.0/K2
           XMIN = Q02M/K2/XMAX
C
C

          X1LMX=LOG(1.0D0 - XMAX)
          X1LMN=LOG(1.0D0 - XMIN)
           X1LD = X1LMX - X1LMN
           PXM =2.0
           DO 203 I=1,200

            X1L = X1LMN + X1LD * xrnd(ipnt)
            ipnt=ipnt+1
            if(ipnt.gt.irdmax) then
             iok=0
             return
            end if

             X = 1.0D0 - EXP(X1L)

          PX1= 1.0D0 + X**2

          xxrnd=xrnd(ipnt)
          ipnt=ipnt+1
          if(ipnt.gt.irdmax) then
           iok=0
           return
          end if
          IF( PX1 .GE. PXM*xxrnd )GOTO 204
 203      CONTINUE

 204      CONTINUE

C         check the constraint is satisfied or not

c         IF(  (1.0D0-X) .LT. K2/Q2MAX ) THEN
c                                        Q2MX = K2
c                                        GOTO 5
c                                       ENDIF

C         write PLPTN and NLPTN of the children

          L = NTOP+1
          PLPTN(1,L) = X*PLPTN(1,NAD)
          PLPTN(2,L) = 0.0

          NLPTN(1,L) = ID
          NLPTN(2,L) = L - NAD
          NLPTN(5,L) = 0
          NLPTN(6,L) = 1

          L = NTOP+2
          PLPTN(1,L) =(1.0D0-X)*PLPTN(1,NAD)
          PLPTN(2,L) = 0.0

C        photon does not branch into electron pair (Now, just appx.)
          NLPTN(1,L) = 0
          NLPTN(2,L) = L - NAD
          NLPTN(3,L) = 0
          NLPTN(5,L) = 1
          NLPTN(6,L) = 1


          PLPTN(2,NAD) = K2

          NLPTN(3,NAD) = 2
          NLPTN(4,NAD) = (L-1) - NAD
          NLPTN(5,NAD) = 1

           NTOP = NTOP + 2

          RETURN

C         not branch
C--( FINAL RADIATION END ) ---------------------------------------
 101      CONTINUE

          PLPTN(2,NAD) = amass2(id)
          NLPTN(3,NAD) = 0
          NLPTN(4,NAD) = 0
          NLPTN(5,NAD) = 1
          
          RETURN
          END
C       SUBROUTINE INPUT                   !ORIGINAL NAME
C       SUBROUTINE QPINPT
C
C Set input values for QEDPS parameters.
C
C     Arguments
C         NEXTRN : input  :number of external particles.
C         AKMASS : input  :table of mass for external particles.
C
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
        SUBROUTINE QPINPT
        IMPLICIT REAL*8(A-H,O-Z)
       
        include 'incl1.h'
        include 'inclk.h'
C
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/KINEM1/S,W,FACT
        COMMON /QPRND / NSEED
        common/usrlun/lu 
        lu=6
*-----------------------------------------------------------------------
C       IBR =0 :initial radiation only
C       IBR =1 :final   radiation only
C           =2 :initial and final radiations without the interference
C           =3 :initial and final radiations with the interference
       IBR = 2

C       NPH    :number of the radiated photons
C       NPH    < 0 : no restriction
C       NPH    > = 0: only events with NPH or <NPH photons
         NPH = -1

C      NALP   : take account of the running effect of the coupling
C             : or not
C      NALP  = 0 : not
C      NALP  >< 0 : include the effect, only due to the electron loop
         NALP = 0

        Q2MAX = S
        totmas=0
        do 1 i=3,nextn
         totmas=totmas+amass1(i)
1       continue
        Q2MIN = totmas**2

        PHMIN =  2.0D-4
        Q02  = (0.1D-5)**2
        Q02M = amlp(1)**2*exp(1.d0)

	nseed=12345679

c      WRITE(lu,*)' ********************'
c      WRITE(lu,*)' * QEDPS PARAMETERS *'
c      WRITE(lu,*)' ********************'
c      WRITE(lu,110)
c110   FORMAT('   Maximum  and minimum values of the virtual photon')
c      WRITE(lu,111)Q2MAX,Q2MIN
c111   FORMAT('  ',2G15.2)
c      WRITE(lu,140)PHMIN
c140   FORMAT(' Minimum Energy of photon (GeV) ',G15.5)
c      WRITE(lu,150)Q02
c150   FORMAT(' Min. virtual mass squared of ini. particle(GeV)',G15.5)
c      WRITE(lu,160)Q02M
c160   FORMAT(' Min. virtual mass squared of fin. particle(GeV)',G15.5)
c      WRITE(lu,170)IBR
c170   FORMAT(' Radiation Flag. 0:I,1:F,2:IF,3:IFC  ',I3)
c      WRITE(lu,171)NPH
c171   FORMAT(' Maximum radiated photon # ,<0:no restri.   ',I3)
c      WRITE(lu,172)NALP
c172   FORMAT(' Taking account of the running effect >0 :yes',I3)
        RETURN
        END
C         SUBROUTINE PSINT  ! ORIGINAL NAME
C         SUBROUTINE QPINT
C
C
C         PLPTN(1, ):  The lightcone fraction
C         PLPTN(2, ):  virtual mass squared
C         PLPTN(3, ):  Pt**2
C         PLPTN(4, ):  x-component of the four momentum
C         PLPTN(5, ):  y-component of the four momentum
C         PLPTN(6, ):  z-component of the four momentum
C         PLPTN(7, ):  E-component of the four momentum
C         PLPTN(8, ):  + component of the lightcone momentum
C         PLPTN(9, ):  - component of the lightcone momentum
C
C         NLPTN(1, ): particle ID=particle# used in GRACE
C                      photon :0
C         NLPTN(2, ): relative address of the parent
C         NLPTN(3, ): number of the children
C         NLPTN(4, ): relative address of the first child
C         NLPTN(5, ): status of the process
C         NLPTN(6, ): spacelike(-1) or timelike(+1)
C
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C         T.Munehisa;improved QEDPS installed by Y.K   09/Aug./'95
C
          SUBROUTINE QPINT(iok)
         IMPLICIT REAL*8(A-H,O-Z)

        include 'inclk.h'
        COMMON/QEDPS1/NALP,NQED
     .,               Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,               IBR,NPH
        COMMON/KINEM1/S,ECM
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
          NTOP=0
          DO   1  LID =1,2
          id=lid    
          NTOP = NTOP + 1
          L = NTOP
          PLPTN(1,L) = 1.0
          PLPTN(2,L) = amass2(id)
          PLPTN(3,L) = 0.0D0
          PLPTN(4,L) = 0.0D0
          PLPTN(5,L) = 0.0D0
          IF ( ID. EQ. 1 )THEN
          e1=(s+amass2(1)-amass2(2))/2.d0/ecm
          PLPTN(6,L) = sqrt( (e1-amass1(1))*(e1+amass1(1)) )
          PLPTN(7,L) = e1
                           ELSE
          e2=(s+amass2(2)-amass2(1))/2.d0/ecm
          PLPTN(6,L) =-sqrt( (e2-amass1(2))*(e2+amass1(2)) )
          PLPTN(7,L) = e2
                           ENDIF
          PLPTN(8,L) = ( abs(plptn(6,l))+plptn(7,l))/sqrt(2.d0)
          PLPTN(9,L) = (-abs(plptn(6,l))+plptn(7,l))/sqrt(2.d0)

          NLPTN(1,L) = ID
          NLPTN(2,L) = 0
          NLPTN(5,L) = 0
          NLPTN(6,L) = -1

  1       CONTINUE

ccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccc    improved QEDPS    1995.8.8
cccccc    start   ccccccccccccccccc
           nccc =1
          if( nccc .eq. 1)then
          DO   4  L =1,2
          call  QPcorr(xc,iok)
          if(iok.eq.0)return
        if( xc .ne. 1.0d0)then
ccc         write(6,*)' improved !! '
         lx = ntop+1
         ntop = ntop+2
          PLPTN(1,Lx) = xc*plptn(1,l)
          PLPTN(2,Lx) = 0.0d0
          PLPTN(3,Lx) = 0.0D0
          PLPTN(4,Lx) = 0.0D0
          PLPTN(5,Lx) = 0.0D0
          plptn(6,lx) =plptn(6,l)*xc
          plptn(7,lx) =plptn(7,l)*xc
          plptn(8,lx) =plptn(8,l)*xc
          NLPTN(1,Lx) = nlptn(1,l)
          NLPTN(2,Lx) = lx-l
          NLPTN(5,Lx) = 0
          NLPTN(6,Lx) = -1
ccccc
c
          NLPTN(3,L) = 2
          NLPTN(4,L) = lx-l
          NLPTN(5,L) = 1
ccccc
          lx = lx+1
           xc1 = 1.0d0 - xc
          PLPTN(1,Lx) = xc1*plptn(1,l)
          PLPTN(2,Lx) = 0.0d0
          PLPTN(3,Lx) = 0.0D0
          PLPTN(4,Lx) = 0.0D0
          PLPTN(5,Lx) = 0.0D0
          plptn(6,lx) =plptn(6,l)*xc1
          plptn(7,lx) =plptn(7,l)*xc1
          plptn(8,lx) =plptn(8,l)*xc1
          NLPTN(1,Lx) = 0
c         NLPTN(2,Lx) = 0
          NLPTN(2,Lx) = lx-l
          NLPTN(5,Lx) = 2
          NLPTN(6,Lx) = 1
                          endif
  4        continue
                                    endif
cccccc    end   ccccccccccccccccc
ccccccccccc    improved QEDPS    1995.8.8 ccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccc

C    end of the momemtum assign for the initial elecrton or positron

C      branching

C      WRITE(6,*)'  ntop =',NTOP
C      CALL OUTLST
          NAD = 1

        IF( IBR .NE. 1 )THEN
   2      CONTINUE
          IF( NLPTN(5,NAD) .EQ. 0) THEN
          CALL QPGEN1(NAD,iok)
          if(iok.eq.0)return
                                   ENDIF
           NAD = NAD + 1
          IF( NAD .LE. NTOP) GOTO 2

         ENDIF

         DO 3 L=1,NTOP
         IF( NLPTN(5,L) .EQ. 2)GOTO 3
         CALL QPCSIN(L,iok)
         if(iok.eq.0) return
 3       CONTINUE

C      WRITE(6,111)
 111   FORMAT('   END OF PSINT ')
         RETURN
         END
C         SUBROUTINE LIMQ2(Q2MX,NAD)       ! ORIGINAL NAME
C         SUBROUTINE QPLMQ2(Q2MX,NAD)
C
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
        SUBROUTINE QPLMQ2(Q2MX,NAD,pe)
        IMPLICIT REAL*8(A-H,O-Z)

        include 'incl1.h'
        include 'inclk.h'

        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/KINEM1/S,w
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
        real*8 pe(4,nextn)
*-----------------------------------------------------------------------
          NPR = NAD - NLPTN(2,NAD)
          IF( NLPTN(1,NPR).EQ.0   )THEN
            id=nlptn(1,nad)
            q2mx=sqrt(plptn(2,npr))-amass1(3)
     .     -amass1(4)
     .     +amass1(id)
            q2mx=q2mx**2 
                                  RETURN
                                   ENDIF
            Q2X = PLPTN(2,NPR)
            X   = PLPTN(1,NAD)/PLPTN(1,NPR)
          Q2MX = X*Q2X
          RETURN
          END
      SUBROUTINE QPNCHK(t,IOK)
C         Y.Kurihara;random # from BASES               24/May /'95
         IMPLICIT REAL*8(A-H,O-Z)

        COMMON/QEDPS1/NALP,NQED
     .,               Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,               IBR,NPH
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
      IOK=1
      IF ( NPH .GE. 0 )THEN
        NNPH = 0
        DO 121 I=1,NTOP
         IF( NLPTN(1,I) .EQ. 0   .AND.  NLPTN(3,I).EQ.0)NNPH=NNPH+1
 121    CONTINUE
        IF(  NNPH  .GT. NPH) IOK=0
      ENDIF
      vmax=999.
      do 1 i=1,ntop 
       if(nlptn(1,i).le.2 .and. plptn(2,i).lt.0.d0)
     .   vmax=min(vmax,plptn(2,i))
1     continue
      write(6,*)' QPNCHK:vmax,t ',vmax,t
      if(vmax.gt.0.d0) return

      if(vmax.lt.t)iok=0
      
      RETURN
      END
         SUBROUTINE QPPCHK

         IMPLICIT REAL*8(A-H,O-Z)
        COMMON /AMCNST/ PI, PI2, RAD, GEVPB
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
        DIMENSION PSUM(3)

        DO 203 I=1,3
 203    PSUM(I)=0.0
C
        pesum=0
        DO 201  J=1,NTOP
      IF( NLPTN(3,J).EQ.0 .AND. NLPTN(6,J) .GT. 0)THEN
        pesum=pesum+plptn(7,j)
        DO 202 I=1,3
 202    PSUM(I)=PSUM(I) + PLPTN(3+I,J)
                                                  ENDIF
 201   CONTINUE
C
       PSUM2 = 0.0
        DO 204 I=1,3
 204    PSUM2  =PSUM(I)**2 + PSUM2
C
        IF( PSUM2 .GT. 1.0E-5)THEN
        WRITE(6,*)' MOMENTUM CONSERVATION ???'
        WRITE(6,*)'  MOMENTUM SUM =',(PSUM(I),I=1,3)
        write(6,*)' psum2 ',psum2
        write(6,*)' pesum ',pesum
                              ENDIF
C

        RETURN
        END
C       SUBROUTINE PREP         ! ORIGINAL NAME
C       SUBROUTINE QEPREP
C
C        Calculation of Sudakov form factor
C  exp(  -\int^{Q2max}_{Q02} dK^2/K^2\int^{1-Q02/K^2}_0dx alpha/2pi P(x)
C  exp(  -\int^{Q2max}_{Q02} dK^2/K^2\int^{1-Q02/K^2}_0dx alpha/2pi P(x)
C
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      18/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
        SUBROUTINE QPPREP

         IMPLICIT REAL*8(A-H,O-Z)
        include 'inclk.h'
        common/usrlun/lu
c       COMMON /AMCNST/ PI, PI2, RAD, GEVPB, ALPHA
C
        COMMON/QEDPS1/NALP,NQED
     .,              Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,              IBR,NPH
        COMMON/QPSDK/PSDK(1000),TMAX,TMIN,NSDK
c       data alpha0/7.2973531d-3/
*-----------------------------------------------------------------------
C        REAL*8 K2

C         P1 =2.0*LOG(K2/Q02)-3.0/2.0
C         Taking account of effect of the running coupling
CC        1992.5.7
CC        ALPHA(Q**2)=ALPHA/(1-ALPHA*C*LOG(Q**2/Q02))
C         C = 1/pi/3:only electron loop
C         P2 = 1/2/PI/C*(-2*(LOG(Q2MAX/Q02)-1)
C             +(2/ALPHA0/C-3/2)*(-LOG(1-ALPHA0*C*LOG(Q2MAX/Q02))
C                               +LOG(1-ALPHA0*C)  ))
C
          C= 1.0/3.0/PI
          NSDK = 1000
          TMAX = LOG(Q2MAX/Q02)
          TMIN = 0.0
           TD = (TMAX - TMIN ) / NSDK
          DO 101 I=1,NSDK
           T = TMIN + TD*I
      IF( NALP .EQ. 0 )THEN
          P2 = 2.0*1.0/2.0*T**2-3.0/2.0*T
          P2 = P2 * ALPHA0 /2.0/PI
                       ELSE
         P2=1.0/2.0/PI/C*(  -2.0*(T-1)
     & +(2.0/ALPHA0/C-3.0/2.0)*(-LOG(1.0-ALPHA0*C*T)
     & +LOG(1.0-ALPHA0*C)  )  )
                       ENDIF

          PSDK(I) = -P2

  101     CONTINUE

c      WRITE(lu,113)
c      WRITE(lu,112)(PSDK(I),I=1,NSDK)
c112   FORMAT('  ',4(G12.3,3X))
c113   FORMAT('  ARRAY OF THE SUDAKOV FORM FATOR')

c      WRITE(lu,111)
c111   FORMAT('   END OF PREP ')
          RETURN
          END
C------------------------------------------------------------------
C     ROTATE PARTICLE IN THE FINAL RADIATION
C------------------------------------------------------------------
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      19/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C         Y.Kurihara;To fit for many body final state  30/May /'95
C
C
C     SUBROUTINE RTFNL(NVPHX,CO) ! ORIGINAL NAME
      SUBROUTINE QPRTF2(NVPHX,pe)
C
      IMPLICIT REAL*8(A-H,O-Z)
      include 'incl1.h'
      include 'inclk.h'
      real*8 pe(4,nextn)
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
CJF
      do 1 id=nvphx+1,ntop
       nad=id
2      continue
       npr=nad-nlptn(2,nad)
       if(nlptn(1,npr).ne.0 .or. nlptn(3,npr).eq.0) then
        nad=npr
        goto 2
       end if
       
       ip = nlptn(1,nad)
       co = pe(3,ip)/sqrt(pe(1,ip)**2+pe(2,ip)**2+pe(3,ip)**2)
       phi= atan2(pe(2,ip),pe(1,ip))
       SI = SQRT((1.D0-CO)*(1.D0+CO))
C
       PX=PLPTN(4,id)
       PY=PLPTN(5,id)
       PZ=PLPTN(6,id)
       PLPTN(4,id)= CO*COS(PHI)*PX-SIN(PHI)*PY+SI*COS(PHI)*PZ
       PLPTN(5,id)= CO*SIN(PHI)*PX+COS(PHI)*PY+SI*SIN(PHI)*PZ
       PLPTN(6,id)=-SI         *PX            +CO         *PZ
 1    continue
C
999   RETURN
      END
C------------------------------------------------------------------
C     ROTATE PARTICLE IN THE FINAL RADIATION
C------------------------------------------------------------------
C Auther: T.Munehisa
C         Y.Kurihara;Modified to fit GRACE/BASES.      19/Feb./'93
C         Y.Kurihara;random # from BASES               24/May /'95
C
C
C     SUBROUTINE RTFNL(NVPHX,CO) ! ORIGINAL NAME
      SUBROUTINE QPRTFL(NVPH,CO,PHI)
C
      IMPLICIT REAL*8(A-H,O-Z)
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
CJF
C     SI = SQRT(1.0 - CO*CO)
      SI = SQRT((1.D0-CO)*(1.D0+CO))
C
      DO 10 N=NVPH+1, NTOP
      PX=PLPTN(4,N)
      PY=PLPTN(5,N)
      PZ=PLPTN(6,N)
      PLPTN(4,N)= CO*COS(PHI)*PX-SIN(PHI)*PY+SI*COS(PHI)*PZ
      PLPTN(5,N)= CO*SIN(PHI)*PX+COS(PHI)*PY+SI*SIN(PHI)*PZ
      PLPTN(6,N)=-SI         *PX            +CO         *PZ
   10 CONTINUE
C
      RETURN
      END
C
C------------------------------------------------------------------
C     BOOST PARTICLES IN THE FINAL RADIATION
C------------------------------------------------------------------
C
C     SUBROUTINE BSFNL(NVPH0  ! ORIGINAL NAME
      SUBROUTINE QPBSFL(NVPH)
C
      IMPLICIT REAL*8(A-H,O-Z)
        COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
*-----------------------------------------------------------------------
C
      DIMENSION PPPP(4,100), PREF(4)
C
      P2 = 0.0
      DO 11 J=1,3
 11   P2       =PLPTN(J+3,NVPH)**2 +P2
      IF( P2   .LE. 1.0E-5)RETURN
C
      DO 1 I=NVPH+1,NTOP
      DO 1 J=1,4
      PPPP(J,I)=PLPTN(J+3,I)
 1    CONTINUE
C
      DO 3 J=1,4
      PREF(J)=PLPTN(J+3,NVPH)
 3    CONTINUE
      NNN1 = NVPH +1
      NNN2 = NTOP
CCC   IF( PREF(4) .LE.  0.0)CALL OUTLST
C
      CALL BOOST$( PPPP , PREF , NNN1 , NNN2 )
C
      DO 2 I=NVPH+1,NTOP
      DO 2 J=1,4
      PLPTN(J+3,I)  =  PPPP(J,I)
 2    CONTINUE

       RETURN
       END
C
C**********
C* BOOST$ *
C**********
C MODULE NO.=034
C.....................MAINTENANCE RECORD AREA........................
C   VERSION 84/06/08
C   UPDATE  00/00/00 : PERSON( XXXXXXX )
C
C....................................................................
C
      SUBROUTINE BOOST$( PPPP , PREF , NNN1 , NNN2 )
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION PPPP(4,1), PREF(4)
CCC   DATA EPS/1.0E-5/
C
C     BOOST A SET OF 4-VECTOR PPPP(4,I) I=NNN1 TO NNN2
C     BY 4-VECTOR PREF(4)
C
C     BE CAREFUL FOR SIZE OF ARRAY PPPP
C
      SUM =0.
      DO 10 K=1,3
   10 SUM = SUM+PREF(K)**2
      P = SQRT(SUM)
      E0 = PREF(4)
      IF(E0.LE.0.0) THEN
          WRITE(6,601) PREF
  601     FORMAT(' #EPOCS3401(W,BOOST$) ENERGY<=0. PREF=',4G15.5)
          E0=1.E-30
          END IF
      BET = P/E0
C                           NO NEED OF BOOST
CCC   IF(BET.LE.EPS) RETURN
      IF(BET.GE.1.0) THEN
          WRITE(6,602) PREF
  602     FORMAT(' #EPOCS3402(W,BOOST$) VELOCITY>=1. PREF=',4G15.5)
          WRITE(6,612) BET
  612     FORMAT(' #EPOCS3402(W,BOOST$) VELOCITY>=1. BET =',G15.5)
CCC       CALL OUTLST
          BET=0.99999
          END IF
      BE2 =    SQRT((1.-BET)*(1.+BET))
      GAM = 1./BE2
      GA1 = 1./(BE2*(1.+BE2))
C
      DO 100 N = NNN1 , NNN2
        S = 0.
        DO 20 K = 1,3
        S = S + PREF(K)*PPPP(K,N)
   20   CONTINUE
        E = PPPP(4,N)
CCC     PX = (GAM-1.)*S/P**2+GAM*E/E0
        PX =  GA1    *S/E0**2+GAM*E/E0
        DO 30 K = 1,3
        PPPP(K,N) = PPPP(K,N) + PX*PREF(K)
   30   CONTINUE
        PPPP(4,N) = GAM*( E + S/E0 )
  100 CONTINUE
C
      RETURN
      END
C**********
C* ROTAT$ *
C**********
C MODULE NO.=039
C.....................MAINTENANCE RECORD AREA........................
C   VERSION 84/06/08
C   UPDATE  00/00/00 : PERSON( XXXXXXX )
C
C....................................................................
C
      SUBROUTINE ROTAT$( PPPP , PHI1, COST , PHI2 , NUMP , NDIM )
C        EULER ROTATION OF PPPP(I,J)
C            I=1 TO NDIM, (I=VECTOR INDEX , NDIM= 3 OR 4 )
C            J=1 TO NUMP, (J=NO. OF PARTICLE)
C
C         ........................
          IMPLICIT REAL*8(A-H,O-Z)
C         ........................
       DIMENSION PPPP( NDIM , NUMP )
C
       COP=COS(PHI1)
       SIP=SIN(PHI1)
       COT=COST
       SIT=SQRT(1.-COST**2)
       COR=COS(PHI2)
       SIR=SIN(PHI2)
C (1) ROTATE PHI1 AROUND Z-AXIS
      DO 10 J=1,NUMP
        PX=PPPP(1,J)
        PY=PPPP(2,J)
        PPPP(1,J)=PX*COP-PY*SIP
        PPPP(2,J)=PX*SIP+PY*COP
   10 CONTINUE
C (2) ROTATE THETA AROUND Y-AXIS
      DO 20 J=1,NUMP
        PX=PPPP(1,J)
        PZ=PPPP(3,J)
        PPPP(3,J)=PZ*COT-PX*SIT
        PPPP(1,J)=PZ*SIT+PX*COT
   20 CONTINUE
C (3) ROTATE PHI2 AROUND Z-AXIS
      DO 30 J=1,NUMP
        PX=PPPP(1,J)
        PY=PPPP(2,J)
        PPPP(1,J)=PX*COR-PY*SIR
        PPPP(2,J)=PX*SIR+PY*COR
   30 CONTINUE
      RETURN
      END
      DOUBLE PRECISION FUNCTION QPRAND( IDUM  )

      IMPLICIT REAL*8(A-H,O-Z)

      COMMON /QPRND / NSEED
      NSEED = NSEED *48828125
      IF(NSEED.LT.0) NSEED=(NSEED+2147483647) + 1
      QPRAND=NSEED*0.4656613D-9
      RETURN
      END
