      SUBROUTINE KINIT
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 4003
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
 
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE 'inclk.h'
      common/usrset/E0,Ea,THEa,IPS,IRUNA,IRUNW,INEUT
*-----------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,Idummy,ICOS3,ICOS4
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),adummy(2),
     .AMASCT(2),adumy2(2),ARESNS(2)
      common /kinemf/ knmgvs, knmhst, knmsfp, knmisr
*- QEDPS ---------------------------------------------------------------
      COMMON/CUTQP /IQEDPS,NOBPHO,COSPHO,EPHOCT,COSOPN
      common/QPRNDM/xrnd(101),ipnt,irdmax
      COMMON/QEDPS1/NALP,NQED
     .,             Q2MAX,Q2MIN,PHMIN,Q02,Q02M
     .,             IBR,NPH,iradi(10)
*-----------------------------------------------------------------------
* 4-body kinematics : fusion type (2-photon, W-fusion)
*
*  Integration variables
*       -q1**2, q10 ,phi3(=0)
*       -q2**2, q20
*        q**2=(p5+p6)**2
*        COS(the5^),Phi5^    in particle 5,6 CM frame
*
*
*
*    P1---------------!---------------------- P3
*                     ! q1=p1-p3
*                     !                  /--- P5
*                     *    q=p5+p6      /
*                    ***---------------<
*                     *                 \
*                     !                  \--- P6
*                     ! q2=p2-p4
*    P2---------------!---------------------- P4
*
*--- 1. Initialize constants for kinematics.
* S = (P1+P2)**2
* W = SQRT(S)
      W = E0
      S = W*W
      totmas=amass1(3)+amass1(4)+amass1(5)+amass1(6)
      if(totmas.gt.w) then
	write(6,*)
     .' CM energy is less than the sum of final particle masses.'
	stop
      end if
*******************************
* Angular cuts in Lab-frame.  *
*******************************
* particle 3
* minimum cos  cut
      COSCUT(1,1)= -cos(THEa*rad)
* maximum cos  cut
      COSCUT(2,1)=  cos(THEa*rad)
* particle 4
* minimum cos  cut
      COSCUT(1,2)= -cos(THEa*rad)
* maximum cos  cut
      COSCUT(2,2)=  cos(THEa*rad)
* particle 5
* minimum cos  cut
      COSCUT(1,3)= -1
* maximum cos  cut
      COSCUT(2,3)=  1
* particle 6
* minimum cos  cut
      COSCUT(1,4)= -1
* maximum cos  cut
      COSCUT(2,4)=  1
 
*******************************
* Energy  cuts in Lab-frame.  *
*******************************
* particle 3
* minimum energy cut
      ENGYCT(1,1) = Ea
* maximum energy cut
      ENGYCT(2,1) = W
* particle 4
* minimum energy cut
      ENGYCT(1,2) = Ea
* maximum energy cut
      ENGYCT(2,2) = W
* particle 5
* minimum energy cut
      ENGYCT(1,3) = AMASS1(5)
* maximum energy cut
      ENGYCT(2,3) = W
* particle 6
* minimum energy cut
      ENGYCT(1,4) = AMASS1(6)
* maximum energy cut
      ENGYCT(2,4) = W
 
*******************************
* Cut on invariant mass of 5-6*
*******************************
* minimum
      AMASCT(1)= AMASS1(5)+AMASS1(6)
* maximum
      AMASCT(2)= W
 
*******************************
* Q2 singularity treatment    *
*******************************
* no-singularity           : IRESNS= 0
* narrow resonance         : IRESNS= 1
* 1/Q2 singularity         : IRESNS=-1
      IRESNS   = 1
      IF(IRESNS.EQ.1) THEN
C If you want treat narrow resonance, you should set resonance mass
C and width.
        ARESNS(1)=AMz
        ARESNS(2)=AGz
c       ARESNS(1)=0
c       ARESNS(2)=0
      END IF
 
*********************************
* mass singularity treatment    *
*********************************
* no-singularity           : ICOS*=0
* mass-singularity         : ICOS*=1
*
*
      ICOS3=0
      ICOS4=0
*-- QEDPS ------------------------------------------------------
C QEDPS IS ON (1) OR OFF(0)
      IQEDPS=Ips
C Particle # for final radiation.
      iradi(3)=0
      iradi(4)=0
      iradi(5)=0
C CUTS FOR RADIATED PHOTONS
C NUMBER OF OBSERVED PHOTON (-1 for no restriction)
c     NOBPHO= 0
      NOBPHO= 2
C ANGULAR CUT FOR OBSERVED PHOTON
      COSPHO=cos(THEa*rad)
C ENERGY CUT  FOR OBSERVED PHOTON
      EPHOCT=Ea
C PHOTON-final particles OPENING ANGLE
      ANGL=0
      COSOPN=COS(ANGL*RAD)
*-- Running alpha-----------------------------------------------
      iralph=Iruna
      if(iralph.eq.3)iralph=0
      call raint(iralph)

 
      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* CM Energy ',W
      WRITE(6,*)'* COSCUT    '
      WRITE(6,'(2F10.3)')COSCUT
      WRITE(6,*)'* ENGYCT    '
      WRITE(6,'(2F10.3)')ENGYCT
      WRITE(6,*)'* AMASCT    '
      WRITE(6,'(2F10.3)')AMASCT
      WRITE(6,*)'* Singularity treatment '
      WRITE(6,*)'*   Q2'
      IF     (IRESNS.EQ.-1) THEN
         WRITE(6,*)'* 1/Q2 singularity '
      ELSE IF(IRESNS.EQ. 0) THEN
         WRITE(6,*)'* NO   singularity '
      ELSE IF(IRESNS.EQ. 1) THEN
         WRITE(6,*)'* Narrow resonance '
         WRITE(6,*)'*  resonance mass and width'
         WRITE(6,*) ARESNS
      END IF
      IF     (ICOS3.EQ.0) THEN
         WRITE(6,*)'* NO mass-singularity for 3 '
      ELSE
         WRITE(6,*)'*    mass-singularity for 3 '
      END IF
      IF     (ICOS4.EQ.0) THEN
         WRITE(6,*)'* NO mass-singularity for 4 '
      ELSE
         WRITE(6,*)'*    mass-singularity for 4 '
      END IF
      WRITE(6,*)'* Running alpha ',iralph
      if(iralph.eq.1) then
        al=alpha*ralph(s)
        WRITE(6,*)'* 1/alpha at CM energy ',1.d0/al
      end if
      WRITE(6,*)'*'
      WRITE(6,*)'*'
 
C SET QEDPS PARAMETERS
      IF(IQEDPS.EQ.1)CALL QPINPT
C Calculation of Sudakov form factor
      IF(IQEDPS.EQ.1)CALL QPPREP

* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX  /2.d0
 
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 2. Dimension of integration variables.
 
c      if(iqedps.eq.1) then
c         NDIM =   50
c         NWILD=   8
c         irdmax=ndim+1 
          irdmax=101
c      else
          NDIM =   8
          NWILD=   8
c      end if
C-----------------------------------------------------------------------
*--- 3. Region of integration.
 
        DO 1 I=1,NDIM
         XL(I)  =   0.D0
         XU(I)  =   1.D0
         if(i.le.8) then
         IG(I)  =   1
         else
         IG(I)  =   0
         end if
1       CONTINUE
C-----------------------------------------------------------------------
*--- 4. Number of iterations
c     if(Ips.eq.0) then
c      ITMX1  =  5
c      ITMX2  =  5
c      NCALL  =100000
c     else
c      ITMX1  =  5
c      ITMX2  =  5
c      NCALL  =2000000
c      NCALL  =4000000
c     end if

 
*--- 5. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 6. Set histograms
c     if( knmgvs .eq. 1 ) then
      NX = 50
      ND = 50
 
c     DO 100 I = 1, NDIM
c        WRITE(XSTR, 110) I
c 110    FORMAT('X(',I2,') SPECTRUM')
c        CALL XHINIT(I, XL(I), XU(I), NX, XSTR)
c 100 CONTINUE
 
         CALL XHINIT(1, 0.d0, w, NX, 'Energy of Particle 3')
         CALL XHINIT(2, 0.d0, w, NX, 'Energy of Particle 4')
         CALL XHINIT(3, 0.d0, w, NX, 'Energy of Particle 5')
         CALL XHINIT(4, 0.d0, w, NX, 'Energy of Particle 6')
         CALL XHINIT(5,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT(6,-1.d0,1.d0, NX, 'cos_the of Particle 4')
         CALL XHINIT(7,-1.d0,1.d0, NX, 'cos_the of Particle 5')
         CALL XHINIT(8,-1.d0,1.d0, NX, 'cos_the of Particle 6')

         CALL XHINIT(10,amass1(5)+amass1(6),w, NX, 'ds/dQ')
         CALL XHINIT(11,-w/2.d0,w/2.d0, 49, 'ds/dQz')
         CALL XHINIT(12, 0.d0,w/2.d0, NX, 'ds/dQt')
         CALL XHINIT(13, 0.d0,w/2.d0, NX, 'ds/dE(gamma)')
         CALL XHINIT(14, 0.d0,w/2.d0, NX, 'ds/dPt(gamma)')

         CALL XHINIT(21,  0.d0,150.d0, 50, 'missing mass')
         CALL XHINIT(22,150.d0,210.d0, 20, 'missing mass')
c     endif
      RETURN
      END
